#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void main(int argc, char * argv[])
{
	FILE * fp, * dest;
	char filenamecat[11];
	char filename[500];
	unsigned int segcount = 0;
	char entry;
	int * segsizearray;
	unsigned int i, j;
	unsigned int bytesread;
	unsigned long filesize;
	unsigned long inputsize = 0;
	char * buffer;

	if(argc < 2) // user has to provide the file to split in the command line
	{
		printf("Use [program exe] source_file_name\n");
		exit(0);
	}

	fp = fopen(argv[1], "rb"); // make file read only
	if(fp == NULL)
	{
		printf("File %s could not be opened.\n", argv[1]);
		exit(0);
	}

	fseek(fp, 0, SEEK_END);
	filesize = (unsigned long)ftell(fp);
	rewind(fp);


	printf("Number of segments to split %s into (max %u): ", argv[1], (unsigned int)0xFFFFFFFF);
	scanf("%d", &segcount);
	if(segcount == 0)
	{
		printf("Segment count should be greater than 0.\n");
		exit(1);
	}
	segsizearray = (int *)malloc(segcount * sizeof(int)); // allocate segcount number of integers to store size of each segment
	if(segsizearray == NULL)
	{
		printf("Could not allocate enough memory.\n");
		exit(1);
	}

	printf("Make them into even file sizes? [y/n] ");
	fflush(stdin);
	scanf("%c", &entry);

	if(entry == 'y' || entry == 'Y') // even split
	{	
		if((filesize / segcount) == 0)
		{
			printf("Segment count seems to be too large to be split into multiple evenly sized segments.\n");
			exit(1);
		}
		printf("Each file except the last will be %d bytes.\n", (filesize / segcount));
		// calculate segment size of every segment except the last
		for(i = 0; i < segcount-1; i++)
		{
			segsizearray[i] = filesize / segcount;
			inputsize += segsizearray[i];
		}
		
		// resolve the file size of the last segment
		if(filesize % segcount != 0) // if filesize is not a multiple of segcount
		{
			printf("Last file will be %d bytes.\n", (filesize - inputsize));
			segsizearray[i] = filesize - inputsize;
		}
		else
			segsizearray[i] = filesize / segcount;
	}
	else // non-even split
	{
		for(i = 0; i < segcount; i++)
		{
			if(inputsize >= filesize)
			{		
				printf("Total size of segments have already reached the original file's length. I'm not allowing any more segments.\n");
				segcount = i;
				break;
			}

			printf("Segment %d size: ", i+1);
			fflush(stdin);
			scanf("%d", &segsizearray[i]);
			inputsize += segsizearray[i];

		}

		// calculate bytes that are remaining after all segment sizes defined
		if(inputsize < filesize)
			printf("Total input size seem to be less than actual file size. So I'll write %d bytes to %s.remain\n", filesize-inputsize, argv[1]);

	}


	rewind(fp);
	// create the files
	for(i = 0; i < segcount; i++)
	{

		strcpy(filename, argv[1]);
		strcat(filename, ".part");
		strcat(filename, itoa(i, filenamecat, 10));
		dest = fopen(filename, "wb");
		freopen(filename, "rb+", dest);
		buffer = (char *)malloc(segsizearray[i]);
		bytesread = fread(buffer, 1, segsizearray[i], fp);
		fwrite(buffer, 1, bytesread, dest);
		printf("Wrote %s, %d bytes.\n", filename, bytesread);
		fclose(dest);
		free(buffer);
	}

	// in non-even segment size splitting, will a remainder segment be needed?
	if(entry != 'y' && entry != 'Y' && inputsize < filesize)
	{
		strcpy(filename, argv[1]);
		strcat(filename, ".remain");
		printf("Writing %s, %d bytes.\n", filename, filesize-inputsize);

		dest = fopen(filename, "wb");
		freopen(filename, "rb+", dest);
		buffer = (char *)malloc(filesize-inputsize);
		bytesread = fread(buffer, 1, filesize-inputsize, fp);
		fwrite(buffer, 1, bytesread, dest);
	}
	free(segsizearray);

}